Hex Artifact Content

Artifact 5526d031f2a0e09d0d7f34467f42f487932c3562:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 61 70 70 6c 79 5f 70 61 74 63 68 65 73 28 29   apply_patches()
0570: 20 7b 0a 09 6c 6f 63 61 6c 20 70 61 74 63 68 0a   {..local patch.
0580: 0a 09 66 6f 72 20 70 61 74 63 68 20 69 6e 20 22  ..for patch in "
0590: 24 7b 70 6b 67 64 69 72 7d 2f 70 61 74 63 68 65  ${pkgdir}/patche
05a0: 73 22 2f 2a 3b 20 64 6f 0a 09 09 69 66 20 5b 20  s"/*; do...if [ 
05b0: 21 20 2d 65 20 22 24 7b 70 61 74 63 68 7d 22 20  ! -e "${patch}" 
05c0: 5d 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e 74 69  ]; then....conti
05d0: 6e 75 65 0a 09 09 66 69 0a 0a 09 09 63 61 73 65  nue...fi....case
05e0: 20 22 24 7b 70 61 74 63 68 7d 22 20 69 6e 0a 09   "${patch}" in..
05f0: 09 09 2a 2e 64 69 66 66 7c 2a 2e 70 61 74 63 68  ..*.diff|*.patch
0600: 29 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 29 0a 09  ).....;;....*)..
0610: 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09 09 09  ...continue.....
0620: 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 69 66 20  ;;...esac....if 
0630: 5b 20 2d 65 20 22 24 7b 70 61 74 63 68 7d 2e 73  [ -e "${patch}.s
0640: 68 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 69 66  h" ]; then....if
0650: 20 21 20 73 68 20 22 24 7b 70 61 74 63 68 7d 2e   ! sh "${patch}.
0660: 73 68 22 3b 20 74 68 65 6e 0a 09 09 09 09 63 6f  sh"; then.....co
0670: 6e 74 69 6e 75 65 0a 09 09 09 66 69 0a 09 09 66  ntinue....fi...f
0680: 69 0a 0a 09 09 70 61 74 63 68 20 2d 70 31 20 3c  i....patch -p1 <
0690: 20 22 24 7b 70 61 74 63 68 7d 22 0a 09 64 6f 6e   "${patch}"..don
06a0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65  e.}..function ve
06b0: 72 69 66 79 52 65 71 75 69 72 65 64 50 61 63 6b  rifyRequiredPack
06c0: 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ages() {..local 
06d0: 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e 20 70 6b  pkg pkgdomain pk
06e0: 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63 61 6c 20  gversion..local 
06f0: 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e 66 69 67  pkgdir pkgconfig
0700: 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a 0a 09 66  dir pkgfound...f
0710: 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b 72 65 71  or pkg in "${req
0720: 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f 0a 09 09  uire[@]}"; do...
0730: 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a 09 09 70  pkgdomain=''...p
0740: 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a 09 09 70  kgversion=''...p
0750: 6b 67 63 68 61 6e 67 65 73 3d 28 43 46 4c 41 47  kgchanges=(CFLAG
0760: 53 20 4c 44 46 4c 41 47 53 20 50 41 54 48 20 50  S LDFLAGS PATH P
0770: 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 29 0a  KG_CONFIG_PATH).
0780: 0a 09 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22  ...case "${pkg}"
0790: 20 69 6e 0a 09 09 09 2a 3a 2a 29 0a 09 09 09 09   in....*:*).....
07a0: 70 6b 67 63 68 61 6e 67 65 73 3d 28 24 28 65 63  pkgchanges=($(ec
07b0: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
07c0: 74 20 2d 66 20 32 20 2d 64 20 27 3a 27 29 29 0a  t -f 2 -d ':')).
07d0: 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f 20  ....pkg="$(echo 
07e0: 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d  "${pkg}" | cut -
07f0: 66 20 31 20 2d 64 20 27 3a 27 29 22 0a 09 09 09  f 1 -d ':')"....
0800: 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 63 61  .;;...esac....ca
0810: 73 65 20 22 24 7b 70 6b 67 7d 22 20 69 6e 0a 09  se "${pkg}" in..
0820: 09 09 2a 2f 2a 40 2a 29 0a 09 09 09 09 70 6b 67  ..*/*@*).....pkg
0830: 64 6f 6d 61 69 6e 3d 22 24 28 65 63 68 6f 20 22  domain="$(echo "
0840: 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d 66  ${pkg}" | cut -f
0850: 20 32 20 2d 64 20 27 40 27 29 22 0a 09 09 09 09   2 -d '@')".....
0860: 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24 28 65 63  pkgversion="$(ec
0870: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
0880: 74 20 2d 66 20 32 20 2d 64 20 27 2f 27 20 7c 20  t -f 2 -d '/' | 
0890: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 40 27 29  cut -f 1 -d '@')
08a0: 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68  ".....pkg="$(ech
08b0: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
08c0: 20 2d 66 20 31 20 2d 64 20 27 2f 27 29 22 0a 09   -f 1 -d '/')"..
08d0: 09 09 09 3b 3b 0a 09 09 09 2a 2f 2a 29 0a 09 09  ...;;....*/*)...
08e0: 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24 28  ..pkgversion="$(
08f0: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
0900: 63 75 74 20 2d 66 20 32 20 2d 64 20 27 2f 27 29  cut -f 2 -d '/')
0910: 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68  ".....pkg="$(ech
0920: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
0930: 20 2d 66 20 31 20 2d 64 20 27 2f 27 29 22 0a 09   -f 1 -d '/')"..
0940: 09 09 09 3b 3b 0a 09 09 09 2a 40 2a 29 0a 09 09  ...;;....*@*)...
0950: 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65  ..pkgdomain="$(e
0960: 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63  cho "${pkg}" | c
0970: 75 74 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22  ut -f 2 -d '@')"
0980: 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f  .....pkg="$(echo
0990: 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20   "${pkg}" | cut 
09a0: 2d 66 20 31 20 2d 64 20 27 40 27 29 22 0a 09 09  -f 1 -d '@')"...
09b0: 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 69  ..;;...esac....i
09c0: 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67 64 6f 6d  f [ -z "${pkgdom
09d0: 61 69 6e 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  ain}" ]; then...
09e0: 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 7b 64 6f  .pkgdomain="${do
09f0: 6d 61 69 6e 7d 22 0a 09 09 66 69 0a 0a 09 09 70  main}"...fi....p
0a00: 6b 67 66 6f 75 6e 64 3d 27 30 27 0a 09 09 66 6f  kgfound='0'...fo
0a10: 72 20 70 6b 67 64 69 72 20 69 6e 20 22 2f 6f 70  r pkgdir in "/op
0a20: 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67 64 6f 6d  t/appfs/${pkgdom
0a30: 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70 6c 61 74  ain}/${pkg}/plat
0a40: 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65 72 73 69  form"/${pkgversi
0a50: 6f 6e 3a 2d 6c 61 74 65 73 74 7d 20 22 2f 6f 70  on:-latest} "/op
0a60: 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67 64 6f 6d  t/appfs/${pkgdom
0a70: 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70 6c 61 74  ain}/${pkg}/plat
0a80: 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65 72 73 69  form"/${pkgversi
0a90: 6f 6e 3a 2d 2a 7d 3b 20 64 6f 0a 09 09 09 70 6b  on:-*}; do....pk
0aa0: 67 63 6f 6e 66 69 67 64 69 72 3d 22 24 7b 70 6b  gconfigdir="${pk
0ab0: 67 64 69 72 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e  gdir}/lib/pkgcon
0ac0: 66 69 67 22 0a 0a 09 09 09 69 66 20 5b 20 21 20  fig".....if [ ! 
0ad0: 2d 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 5d  -d "${pkgdir}" ]
0ae0: 3b 20 74 68 65 6e 0a 09 09 09 09 63 6f 6e 74 69  ; then.....conti
0af0: 6e 75 65 0a 09 09 09 66 69 0a 0a 09 09 09 23 20  nue....fi.....# 
0b00: 49 66 20 74 68 65 20 70 61 63 6b 61 67 65 20 76  If the package v
0b10: 65 72 73 69 6f 6e 20 77 61 73 20 75 6e 73 70 65  ersion was unspe
0b20: 63 69 66 69 65 64 2c 20 66 75 6c 6c 79 20 72 65  cified, fully re
0b30: 73 6f 6c 76 65 0a 09 09 09 23 20 74 68 65 20 64  solve....# the d
0b40: 69 72 65 63 74 6f 72 79 20 74 68 61 74 20 77 65  irectory that we
0b50: 20 66 6f 75 6e 64 0a 09 09 09 69 66 20 5b 20 2d   found....if [ -
0b60: 7a 20 22 24 7b 70 6b 67 76 65 72 73 69 6f 6e 7d  z "${pkgversion}
0b70: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70 6b  " ]; then.....pk
0b80: 67 64 69 72 3d 22 24 28 72 65 61 64 6c 69 6e 6b  gdir="$(readlink
0b90: 20 2d 66 20 22 24 7b 70 6b 67 64 69 72 7d 22 29   -f "${pkgdir}")
0ba0: 22 0a 09 09 09 66 69 0a 0a 09 09 09 70 6b 67 66  "....fi.....pkgf
0bb0: 6f 75 6e 64 3d 27 31 27 0a 0a 09 09 09 66 6f 72  ound='1'.....for
0bc0: 20 70 6b 67 63 68 61 6e 67 65 20 69 6e 20 22 24   pkgchange in "$
0bd0: 7b 70 6b 67 63 68 61 6e 67 65 73 5b 40 5d 7d 22  {pkgchanges[@]}"
0be0: 3b 20 64 6f 0a 09 09 09 09 63 61 73 65 20 22 24  ; do.....case "$
0bf0: 7b 70 6b 67 63 68 61 6e 67 65 7d 22 20 69 6e 0a  {pkgchange}" in.
0c00: 09 09 09 09 09 43 46 4c 41 47 53 29 0a 09 09 09  .....CFLAGS)....
0c10: 09 09 09 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c  ...CFLAGS="${CFL
0c20: 41 47 53 7d 20 2d 49 24 7b 70 6b 67 64 69 72 7d  AGS} -I${pkgdir}
0c30: 2f 69 6e 63 6c 75 64 65 22 0a 09 09 09 09 09 09  /include".......
0c40: 43 50 50 46 4c 41 47 53 3d 22 24 7b 43 50 50 46  CPPFLAGS="${CPPF
0c50: 4c 41 47 53 7d 20 2d 49 24 7b 70 6b 67 64 69 72  LAGS} -I${pkgdir
0c60: 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09 09 09 09  }/include"......
0c70: 09 65 78 70 6f 72 74 20 43 46 4c 41 47 53 20 43  .export CFLAGS C
0c80: 50 50 46 4c 41 47 53 0a 09 09 09 09 09 09 3b 3b  PPFLAGS.......;;
0c90: 0a 09 09 09 09 09 4c 44 46 4c 41 47 53 29 0a 09  ......LDFLAGS)..
0ca0: 09 09 09 09 09 4c 44 46 4c 41 47 53 3d 22 24 7b  .....LDFLAGS="${
0cb0: 4c 44 46 4c 41 47 53 7d 20 2d 4c 24 7b 70 6b 67  LDFLAGS} -L${pkg
0cc0: 64 69 72 7d 2f 6c 69 62 20 2d 57 6c 2c 2d 72 70  dir}/lib -Wl,-rp
0cd0: 61 74 68 2c 24 7b 70 6b 67 64 69 72 7d 2f 6c 69  ath,${pkgdir}/li
0ce0: 62 22 0a 09 09 09 09 09 09 65 78 70 6f 72 74 20  b".......export 
0cf0: 4c 44 46 4c 41 47 53 0a 09 09 09 09 09 09 3b 3b  LDFLAGS.......;;
0d00: 0a 09 09 09 09 09 50 41 54 48 29 0a 09 09 09 09  ......PATH).....
0d10: 09 09 50 41 54 48 3d 22 24 7b 50 41 54 48 7d 3a  ..PATH="${PATH}:
0d20: 24 7b 70 6b 67 64 69 72 7d 2f 62 69 6e 22 0a 09  ${pkgdir}/bin"..
0d30: 09 09 09 09 09 65 78 70 6f 72 74 20 50 41 54 48  .....export PATH
0d40: 0a 09 09 09 09 09 09 3b 3b 0a 09 09 09 09 09 50  .......;;......P
0d50: 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 29 0a  KG_CONFIG_PATH).
0d60: 09 09 09 09 09 09 69 66 20 5b 20 2d 64 20 22 24  ......if [ -d "$
0d70: 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72 7d 22 20  {pkgconfigdir}" 
0d80: 5d 3b 20 74 68 65 6e 0a 09 09 09 09 09 09 09 50  ]; then........P
0d90: 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 3d 22  KG_CONFIG_PATH="
0da0: 24 7b 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54  ${PKG_CONFIG_PAT
0db0: 48 7d 3a 24 7b 70 6b 67 63 6f 6e 66 69 67 64 69  H}:${pkgconfigdi
0dc0: 72 7d 22 0a 09 09 09 09 09 09 09 65 78 70 6f 72  r}"........expor
0dd0: 74 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54  t PKG_CONFIG_PAT
0de0: 48 0a 09 09 09 09 09 09 66 69 0a 09 09 09 09 09  H.......fi......
0df0: 09 3b 3b 0a 09 09 09 09 65 73 61 63 0a 09 09 09  .;;.....esac....
0e00: 64 6f 6e 65 0a 09 09 64 6f 6e 65 0a 0a 09 09 69  done...done....i
0e10: 66 20 5b 20 22 24 7b 70 6b 67 66 6f 75 6e 64 7d  f [ "${pkgfound}
0e20: 22 20 3d 20 27 30 27 20 5d 3b 20 74 68 65 6e 0a  " = '0' ]; then.
0e30: 09 09 09 64 69 65 20 22 50 61 63 6b 61 67 65 20  ...die "Package 
0e40: 24 7b 70 6b 67 7d 2f 24 7b 70 6b 67 76 65 72 73  ${pkg}/${pkgvers
0e50: 69 6f 6e 3a 2d 2a 7d 40 24 7b 70 6b 67 64 6f 6d  ion:-*}@${pkgdom
0e60: 61 69 6e 7d 20 6e 6f 74 20 66 6f 75 6e 64 2e 22  ain} not found."
0e70: 0a 09 09 66 69 0a 09 64 6f 6e 65 0a 7d 0a 0a 66  ...fi..done.}..f
0e80: 75 6e 63 74 69 6f 6e 20 76 65 72 69 66 79 50 72  unction verifyPr
0e90: 65 72 65 71 75 69 73 69 74 65 73 28 29 20 7b 0a  erequisites() {.
0ea0: 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64  .:.}..function d
0eb0: 65 74 65 72 6d 69 6e 65 4f 73 41 72 63 68 28 29  etermineOsArch()
0ec0: 20 7b 0a 09 6f 73 3d 22 24 28 75 6e 61 6d 65 20   {..os="$(uname 
0ed0: 2d 73 20 7c 20 64 64 20 63 6f 6e 76 3d 6c 63 61  -s | dd conv=lca
0ee0: 73 65 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 29 22  se 2>/dev/null)"
0ef0: 0a 09 61 72 63 68 3d 22 24 28 75 6e 61 6d 65 20  ..arch="$(uname 
0f00: 2d 6d 20 7c 20 64 64 20 63 6f 6e 76 3d 6c 63 61  -m | dd conv=lca
0f10: 73 65 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 29 22  se 2>/dev/null)"
0f20: 0a 0a 09 63 61 73 65 20 22 24 7b 61 72 63 68 7d  ...case "${arch}
0f30: 22 20 69 6e 0a 09 09 69 3f 38 36 29 0a 09 09 09  " in...i?86)....
0f40: 61 72 63 68 3d 27 69 78 38 36 27 0a 09 09 09 3b  arch='ix86'....;
0f50: 3b 0a 09 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74  ;..esac.}..funct
0f60: 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65 50 72 65  ion determinePre
0f70: 66 69 78 28 29 20 7b 0a 09 64 65 74 65 72 6d 69  fix() {..determi
0f80: 6e 65 4f 73 41 72 63 68 0a 0a 09 70 72 65 66 69  neOsArch...prefi
0f90: 78 73 75 66 66 69 78 3d 22 24 7b 70 6b 67 7d 2f  xsuffix="${pkg}/
0fa0: 24 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d 2f 24 7b  ${os}-${arch}/${
0fb0: 76 65 72 73 69 6f 6e 7d 22 0a 09 70 72 65 66 69  version}"..prefi
0fc0: 78 3d 22 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b  x="/opt/appfs/${
0fd0: 64 6f 6d 61 69 6e 7d 2f 24 7b 70 72 65 66 69 78  domain}/${prefix
0fe0: 73 75 66 66 69 78 7d 22 0a 09 64 65 73 74 64 69  suffix}"..destdi
0ff0: 72 3d 22 24 28 70 77 64 29 2f 49 4e 53 54 22 0a  r="$(pwd)/INST".
1000: 0a 09 6d 6b 64 69 72 20 22 24 7b 64 65 73 74 64  ..mkdir "${destd
1010: 69 72 7d 22 20 7c 7c 20 64 69 65 0a 7d 0a 0a 66  ir}" || die.}..f
1020: 75 6e 63 74 69 6f 6e 20 70 72 65 63 6f 6e 66 69  unction preconfi
1030: 67 75 72 65 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66  gure() {..:.}..f
1040: 75 6e 63 74 69 6f 6e 20 70 6f 73 74 63 6f 6e 66  unction postconf
1050: 69 67 75 72 65 28 29 20 7b 0a 09 3a 0a 7d 0a 0a  igure() {..:.}..
1060: 66 75 6e 63 74 69 6f 6e 20 63 6f 6e 66 69 67 75  function configu
1070: 72 65 5f 67 63 63 28 29 20 7b 0a 09 6c 6f 63 61  re_gcc() {..loca
1080: 6c 20 67 6c 69 62 63 64 69 72 20 6c 69 6e 75 78  l glibcdir linux
1090: 68 65 61 64 65 72 73 64 69 72 0a 09 6c 6f 63 61  headersdir..loca
10a0: 6c 20 64 79 6e 6c 69 6e 6b 65 72 0a 09 6c 6f 63  l dynlinker..loc
10b0: 61 6c 20 67 63 63 5f 64 65 66 61 75 6c 74 5f 68  al gcc_default_h
10c0: 65 61 64 65 72 73 0a 0a 09 67 6c 69 62 63 64 69  eaders...glibcdi
10d0: 72 3d 22 2f 6f 70 74 2f 61 70 70 66 73 2f 63 6f  r="/opt/appfs/co
10e0: 72 65 2e 61 70 70 66 73 2e 72 6b 65 65 6e 65 2e  re.appfs.rkeene.
10f0: 6f 72 67 2f 67 6c 69 62 63 2f 70 6c 61 74 66 6f  org/glibc/platfo
1100: 72 6d 2f 6c 61 74 65 73 74 22 0a 09 67 6c 69 62  rm/latest"..glib
1110: 63 64 69 72 3d 22 24 28 72 65 61 64 6c 69 6e 6b  cdir="$(readlink
1120: 20 2d 66 20 22 24 7b 67 6c 69 62 63 64 69 72 7d   -f "${glibcdir}
1130: 22 29 22 0a 0a 09 6c 69 6e 75 78 68 65 61 64 65  ")"...linuxheade
1140: 72 73 64 69 72 3d 22 2f 6f 70 74 2f 61 70 70 66  rsdir="/opt/appf
1150: 73 2f 63 6f 72 65 2e 61 70 70 66 73 2e 72 6b 65  s/core.appfs.rke
1160: 65 6e 65 2e 6f 72 67 2f 6c 69 6e 75 78 2d 68 65  ene.org/linux-he
1170: 61 64 65 72 73 2f 70 6c 61 74 66 6f 72 6d 2f 6c  aders/platform/l
1180: 61 74 65 73 74 22 0a 09 6c 69 6e 75 78 68 65 61  atest"..linuxhea
1190: 64 65 72 73 64 69 72 3d 22 24 28 72 65 61 64 6c  dersdir="$(readl
11a0: 69 6e 6b 20 2d 66 20 22 24 7b 6c 69 6e 75 78 68  ink -f "${linuxh
11b0: 65 61 64 65 72 73 64 69 72 7d 22 29 22 0a 0a 09  eadersdir}")"...
11c0: 64 79 6e 6c 69 6e 6b 65 72 3d 22 24 28 6c 73 20  dynlinker="$(ls 
11d0: 22 24 7b 67 6c 69 62 63 64 69 72 7d 22 2f 6c 69  "${glibcdir}"/li
11e0: 62 2f 6c 64 2d 6c 69 6e 75 78 2a 2e 73 6f 2e 2a  b/ld-linux*.so.*
11f0: 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 0a   | tail -n 1)"..
1200: 09 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 64 79  .if [ ! -f "${dy
1210: 6e 6c 69 6e 6b 65 72 7d 22 20 5d 3b 20 74 68 65  nlinker}" ]; the
1220: 6e 0a 09 09 64 69 65 20 27 67 6c 69 62 63 20 64  n...die 'glibc d
1230: 69 72 65 63 74 6f 72 79 20 69 73 20 6e 6f 74 20  irectory is not 
1240: 61 76 61 69 6c 61 62 6c 65 20 28 61 70 70 66 73  available (appfs
1250: 20 72 75 6e 6e 69 6e 67 2f 77 6f 72 6b 69 6e 67   running/working
1260: 3f 29 27 0a 09 66 69 0a 0a 09 67 63 63 5f 64 65  ?)'..fi...gcc_de
1270: 66 61 75 6c 74 5f 68 65 61 64 65 72 73 3d 22 24  fault_headers="$
1280: 28 65 63 68 6f 20 27 27 20 7c 20 24 7b 43 50 50  (echo '' | ${CPP
1290: 3a 2d 63 70 70 7d 20 2d 76 20 32 3e 26 31 20 7c  :-cpp} -v 2>&1 |
12a0: 20 73 65 64 20 27 2f 5e 45 6e 64 20 6f 66 20 73   sed '/^End of s
12b0: 65 61 72 63 68 20 6c 69 73 74 2f 2c 24 20 64 3b  earch list/,$ d;
12c0: 30 2c 2f 73 65 61 72 63 68 20 73 74 61 72 74 73  0,/search starts
12d0: 20 68 65 72 65 3a 24 2f 20 64 27 20 7c 20 67 72   here:$/ d' | gr
12e0: 65 70 20 27 2f 67 63 63 2f 27 20 7c 20 73 65 64  ep '/gcc/' | sed
12f0: 20 27 73 40 5e 20 2a 40 2d 49 40 27 20 7c 20 74   's@^ *@-I@' | t
1300: 72 20 24 27 5c 6e 27 20 27 20 27 29 22 0a 0a 09  r $'\n' ' ')"...
1310: 43 43 3d 22 24 7b 43 43 3a 2d 67 63 63 7d 20 2d  CC="${CC:-gcc} -
1320: 6e 6f 73 74 64 69 6e 63 20 24 7b 67 63 63 5f 64  nostdinc ${gcc_d
1330: 65 66 61 75 6c 74 5f 68 65 61 64 65 72 73 7d 20  efault_headers} 
1340: 2d 49 24 7b 67 6c 69 62 63 64 69 72 7d 2f 69 6e  -I${glibcdir}/in
1350: 63 6c 75 64 65 22 0a 0a 09 69 66 20 21 20 65 63  clude"...if ! ec
1360: 68 6f 20 22 20 24 7b 72 65 71 75 69 72 65 5b 2a  ho " ${require[*
1370: 5d 7d 20 22 20 7c 20 67 72 65 70 20 27 20 6c 69  ]} " | grep ' li
1380: 6e 75 78 2d 68 65 61 64 65 72 73 5b 2f 40 3a 20  nux-headers[/@: 
1390: 5d 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74  ]' >/dev/null; t
13a0: 68 65 6e 0a 09 09 43 43 3d 22 24 7b 43 43 7d 20  hen...CC="${CC} 
13b0: 2d 49 24 7b 6c 69 6e 75 78 68 65 61 64 65 72 73  -I${linuxheaders
13c0: 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 66  dir}/include"..f
13d0: 69 0a 0a 09 42 55 49 4c 44 5f 43 43 3d 22 24 7b  i...BUILD_CC="${
13e0: 43 43 7d 22 0a 09 48 4f 53 54 5f 43 43 3d 22 24  CC}"..HOST_CC="$
13f0: 7b 43 43 7d 22 0a 09 4c 44 46 4c 41 47 53 3d 22  {CC}"..LDFLAGS="
1400: 24 7b 4c 44 46 4c 41 47 53 7d 20 2d 4c 24 7b 67  ${LDFLAGS} -L${g
1410: 6c 69 62 63 64 69 72 7d 2f 6c 69 62 20 2d 57 6c  libcdir}/lib -Wl
1420: 2c 2d 2d 72 70 61 74 68 2c 24 7b 67 6c 69 62 63  ,--rpath,${glibc
1430: 64 69 72 7d 2f 6c 69 62 20 2d 57 6c 2c 2d 2d 64  dir}/lib -Wl,--d
1440: 79 6e 61 6d 69 63 2d 6c 69 6e 6b 65 72 2c 24 7b  ynamic-linker,${
1450: 64 79 6e 6c 69 6e 6b 65 72 7d 22 0a 09 50 4b 47  dynlinker}"..PKG
1460: 5f 43 4f 4e 46 49 47 5f 4c 49 42 44 49 52 3d 22  _CONFIG_LIBDIR="
1470: 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62 2f  ${glibcdir}/lib/
1480: 70 6b 67 63 6f 6e 66 69 67 22 0a 09 65 78 70 6f  pkgconfig"..expo
1490: 72 74 20 43 43 20 42 55 49 4c 44 5f 43 43 20 48  rt CC BUILD_CC H
14a0: 4f 53 54 5f 43 43 20 4c 44 46 4c 41 47 53 20 50  OST_CC LDFLAGS P
14b0: 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49 42 44 49 52  KG_CONFIG_LIBDIR
14c0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6f 6e  .}..function con
14d0: 66 69 67 75 72 65 28 29 20 7b 0a 09 63 6f 6e 66  figure() {..conf
14e0: 69 67 75 72 65 5f 67 63 63 0a 09 2e 2f 63 6f 6e  igure_gcc.../con
14f0: 66 69 67 75 72 65 20 2d 2d 70 72 65 66 69 78 3d  figure --prefix=
1500: 22 24 7b 70 72 65 66 69 78 7d 22 20 2d 2d 73 79  "${prefix}" --sy
1510: 73 63 6f 6e 66 64 69 72 3d 22 24 7b 70 72 65 66  sconfdir="${pref
1520: 69 78 7d 2f 65 74 63 22 20 2d 2d 6c 69 62 64 69  ix}/etc" --libdi
1530: 72 3d 22 24 7b 70 72 65 66 69 78 7d 2f 6c 69 62  r="${prefix}/lib
1540: 22 20 2d 2d 6c 6f 63 61 6c 73 74 61 74 65 64 69  " --localstatedi
1550: 72 3d 2f 76 61 72 20 22 24 7b 63 6f 6e 66 69 67  r=/var "${config
1560: 75 72 65 5f 65 78 74 72 61 5b 40 5d 7d 22 0a 7d  ure_extra[@]}".}
1570: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 62 75  ..function prebu
1580: 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ild() {..:.}..fu
1590: 6e 63 74 69 6f 6e 20 70 6f 73 74 62 75 69 6c 64  nction postbuild
15a0: 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74  () {..:.}..funct
15b0: 69 6f 6e 20 62 75 69 6c 64 28 29 20 7b 0a 09 67  ion build() {..g
15c0: 72 65 70 20 22 44 45 53 54 44 49 52 22 20 4d 61  rep "DESTDIR" Ma
15d0: 6b 65 66 69 6c 65 20 3e 2f 64 65 76 2f 6e 75 6c  kefile >/dev/nul
15e0: 6c 20 7c 7c 20 64 69 65 20 22 44 6f 6e 27 74 20  l || die "Don't 
15f0: 6b 6e 6f 77 20 68 6f 77 20 74 6f 20 62 75 69 6c  know how to buil
1600: 64 20 74 68 69 73 20 73 6f 66 74 77 61 72 65 22  d this software"
1610: 0a 0a 09 6d 61 6b 65 0a 7d 0a 0a 66 75 6e 63 74  ...make.}..funct
1620: 69 6f 6e 20 70 72 65 69 6e 73 74 61 6c 6c 28 29  ion preinstall()
1630: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
1640: 6e 20 70 6f 73 74 69 6e 73 74 61 6c 6c 28 29 20  n postinstall() 
1650: 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  {..:.}..function
1660: 20 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 6d 61   install() {..ma
1670: 6b 65 20 69 6e 73 74 61 6c 6c 20 44 45 53 54 44  ke install DESTD
1680: 49 52 3d 22 24 7b 64 65 73 74 64 69 72 7d 22 0a  IR="${destdir}".
1690: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6c 65 61  }..function clea
16a0: 6e 75 70 28 29 20 7b 0a 09 63 64 20 22 24 7b 77  nup() {..cd "${w
16b0: 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74  orkdir}" || exit
16c0: 20 31 0a 09 63 64 20 2e 2e 20 7c 7c 20 65 78 69   1..cd .. || exi
16d0: 74 20 31 0a 09 72 6d 20 2d 72 66 20 22 24 7b 77  t 1..rm -rf "${w
16e0: 6f 72 6b 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63  orkdir}".}..func
16f0: 74 69 6f 6e 20 64 69 65 28 29 20 7b 0a 09 6c 6f  tion die() {..lo
1700: 63 61 6c 20 6d 65 73 73 61 67 65 0a 0a 09 6d 65  cal message...me
1710: 73 73 61 67 65 3d 22 24 31 22 0a 0a 09 69 66 20  ssage="$1"...if 
1720: 5b 20 2d 6e 20 22 24 7b 6d 65 73 73 61 67 65 7d  [ -n "${message}
1730: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f  " ]; then...echo
1740: 20 22 65 72 72 6f 72 3a 20 24 7b 6d 65 73 73 61   "error: ${messa
1750: 67 65 7d 22 20 3e 26 32 0a 09 66 69 0a 0a 09 65  ge}" >&2..fi...e
1760: 78 69 74 20 31 0a 7d 0a 0a 73 63 72 69 70 74 64  xit 1.}..scriptd
1770: 69 72 3d 22 24 28 63 64 20 22 24 28 64 69 72 6e  ir="$(cd "$(dirn
1780: 61 6d 65 20 22 24 28 77 68 69 63 68 20 22 24 30  ame "$(which "$0
1790: 22 29 22 29 22 20 26 26 20 70 77 64 29 22 0a 69  ")")" && pwd)".i
17a0: 66 20 5b 20 2d 7a 20 22 24 7b 73 63 72 69 70 74  f [ -z "${script
17b0: 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65  dir}" ]; then..e
17c0: 63 68 6f 20 22 55 6e 61 62 6c 65 20 74 6f 20 6c  cho "Unable to l
17d0: 6f 63 61 74 65 20 73 63 72 69 70 74 20 64 69 72  ocate script dir
17e0: 65 63 74 6f 72 79 22 20 3e 26 32 0a 0a 09 65 78  ectory" >&2...ex
17f0: 69 74 20 31 0a 66 69 0a 0a 63 64 20 22 24 7b 73  it 1.fi..cd "${s
1800: 63 72 69 70 74 64 69 72 7d 22 20 7c 7c 20 65 78  criptdir}" || ex
1810: 69 74 20 31 0a 0a 69 66 20 5b 20 2d 66 20 27 62  it 1..if [ -f 'b
1820: 75 69 6c 64 2e 63 6f 6e 66 27 20 5d 3b 20 74 68  uild.conf' ]; th
1830: 65 6e 0a 09 2e 20 27 62 75 69 6c 64 2e 63 6f 6e  en... 'build.con
1840: 66 27 0a 66 69 0a 0a 69 66 20 5b 20 2d 64 20 22  f'.fi..if [ -d "
1850: 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 20 5d 3b 20  pkgs/${pkg}" ]; 
1860: 74 68 65 6e 0a 09 70 6b 67 64 69 72 3d 22 24 28  then..pkgdir="$(
1870: 70 77 64 29 2f 70 6b 67 73 2f 24 7b 70 6b 67 7d  pwd)/pkgs/${pkg}
1880: 22 0a 09 70 6b 67 66 69 6c 65 3d 22 24 7b 70 6b  "..pkgfile="${pk
1890: 67 64 69 72 7d 2f 69 6e 66 6f 22 0a 65 6c 73 65  gdir}/info".else
18a0: 0a 09 70 6b 67 66 69 6c 65 3d 22 24 28 70 77 64  ..pkgfile="$(pwd
18b0: 29 2f 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09  )/pkgs/${pkg}"..
18c0: 70 6b 67 64 69 72 3d 22 24 7b 70 6b 67 66 69 6c  pkgdir="${pkgfil
18d0: 65 7d 22 0a 66 69 0a 0a 69 66 20 5b 20 21 20 2d  e}".fi..if [ ! -
18e0: 65 20 22 24 7b 70 6b 67 66 69 6c 65 7d 22 20 5d  e "${pkgfile}" ]
18f0: 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 49 6e  ; then..echo "In
1900: 76 61 6c 69 64 20 70 61 63 6b 61 67 65 2e 22 20  valid package." 
1910: 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a  >&2...exit 1.fi.
1920: 0a 70 6b 67 64 61 74 65 3d 22 24 28 66 6f 72 20  .pkgdate="$(for 
1930: 61 72 74 69 66 61 63 74 20 69 6e 20 24 28 66 69  artifact in $(fi
1940: 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 2d  nd "${pkgdir}" -
1950: 74 79 70 65 20 66 20 2d 70 72 69 6e 74 30 20 7c  type f -print0 |
1960: 20 78 61 72 67 73 20 2d 6e 20 31 20 2d 30 20 66   xargs -n 1 -0 f
1970: 6f 73 73 69 6c 20 66 69 6e 66 6f 20 2d 2d 6c 69  ossil finfo --li
1980: 6d 69 74 20 31 20 2d 2d 77 69 64 74 68 20 30 20  mit 1 --width 0 
1990: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 67 72  2>/dev/null | gr
19a0: 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d 5b  ep '^[0-9][0-9][
19b0: 30 2d 39 5d 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b  0-9][0-9]-[0-9][
19c0: 30 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 20  0-9]-[0-9][0-9] 
19d0: 27 20 7c 20 73 65 64 20 27 73 40 5e 5b 5e 20 5d  ' | sed 's@^[^ ]
19e0: 2a 20 5c 5b 40 40 3b 73 40 5c 5d 2e 2a 40 40 27  * \[@@;s@\].*@@'
19f0: 20 7c 20 73 6f 72 74 20 2d 75 29 3b 20 64 6f 20   | sort -u); do 
1a00: 66 6f 73 73 69 6c 20 69 6e 66 6f 20 22 24 7b 61  fossil info "${a
1a10: 72 74 69 66 61 63 74 7d 22 20 7c 20 61 77 6b 20  rtifact}" | awk 
1a20: 27 2f 5e 75 75 69 64 3a 2f 7b 20 70 72 69 6e 74  '/^uuid:/{ print
1a30: 20 24 33 20 24 34 20 7d 27 20 7c 20 73 65 64 20   $3 $4 }' | sed 
1a40: 27 73 40 5b 2d 3a 5d 40 40 67 3b 73 40 2e 2e 24  's@[-:]@@g;s@..$
1a50: 40 5c 2e 26 40 27 3b 20 64 6f 6e 65 20 7c 20 73  @\.&@'; done | s
1a60: 6f 72 74 20 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e  ort -n | tail -n
1a70: 20 31 29 22 0a 69 66 20 5b 20 2d 7a 20 22 24 7b   1)".if [ -z "${
1a80: 70 6b 67 64 61 74 65 7d 22 20 5d 3b 20 74 68 65  pkgdate}" ]; the
1a90: 6e 0a 09 70 6b 67 64 61 74 65 3d 22 24 28 66 69  n..pkgdate="$(fi
1aa0: 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 2d  nd "${pkgdir}" -
1ab0: 74 79 70 65 20 66 20 2d 70 72 69 6e 74 66 20 27  type f -printf '
1ac0: 25 54 59 25 54 6d 25 54 64 25 54 48 25 54 4d 2e  %TY%Tm%Td%TH%TM.
1ad0: 25 54 53 5c 6e 27 20 32 3e 2f 64 65 76 2f 6e 75  %TS\n' 2>/dev/nu
1ae0: 6c 6c 20 7c 20 63 75 74 20 2d 66 20 31 2d 32 20  ll | cut -f 1-2 
1af0: 2d 64 20 27 2e 27 20 7c 20 73 6f 72 74 20 2d 6e  -d '.' | sort -n
1b00: 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 66   | tail -n 1)".f
1b10: 69 0a 0a 2e 20 22 24 7b 70 6b 67 66 69 6c 65 7d  i... "${pkgfile}
1b20: 22 0a 0a 61 72 63 68 69 76 65 64 69 72 3d 22 24  "..archivedir="$
1b30: 28 70 77 64 29 2f 41 52 43 48 49 56 45 22 0a 77  (pwd)/ARCHIVE".w
1b40: 6f 72 6b 64 69 72 3d 22 77 6f 72 6b 64 69 72 2d  orkdir="workdir-
1b50: 24 24 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e  $$${RANDOM}${RAN
1b60: 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 22 0a 70  DOM}${RANDOM}".p
1b70: 6b 67 61 72 63 68 69 76 65 3d 22 24 7b 61 72 63  kgarchive="${arc
1b80: 68 69 76 65 64 69 72 7d 2f 24 7b 70 6b 67 7d 2d  hivedir}/${pkg}-
1b90: 24 7b 76 65 72 73 69 6f 6e 7d 22 0a 6d 6b 64 69  ${version}".mkdi
1ba0: 72 20 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d  r "${archivedir}
1bb0: 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  " >/dev/null 2>/
1bc0: 64 65 76 2f 6e 75 6c 6c 0a 6d 6b 64 69 72 20 22  dev/null.mkdir "
1bd0: 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65  ${workdir}" || e
1be0: 78 69 74 20 31 0a 63 64 20 22 24 7b 77 6f 72 6b  xit 1.cd "${work
1bf0: 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  dir}" || exit 1.
1c00: 77 6f 72 6b 64 69 72 3d 22 24 28 70 77 64 29 22  workdir="$(pwd)"
1c10: 0a 0a 23 20 44 6f 77 6e 6c 6f 61 64 0a 64 6f 77  ..# Download.dow
1c20: 6e 6c 6f 61 64 0a 0a 23 20 45 78 74 72 61 63 74  nload..# Extract
1c30: 0a 65 78 74 72 61 63 74 0a 0a 23 20 49 66 20 77  .extract..# If w
1c40: 65 20 6a 75 73 74 20 68 61 76 65 20 6f 6e 65 20  e just have one 
1c50: 64 69 72 65 63 74 6f 72 79 2c 20 75 73 65 20 74  directory, use t
1c60: 68 61 74 20 64 69 72 65 63 74 6f 72 79 0a 64 69  hat directory.di
1c70: 72 3d 22 24 28 65 63 68 6f 20 2a 29 22 0a 69 66  r="$(echo *)".if
1c80: 20 5b 20 2d 65 20 22 24 7b 64 69 72 7d 22 20 5d   [ -e "${dir}" ]
1c90: 3b 20 74 68 65 6e 0a 09 6d 76 20 22 24 7b 64 69  ; then..mv "${di
1ca0: 72 7d 22 2f 2a 20 2e 0a 66 69 0a 0a 23 20 56 65  r}"/* ..fi..# Ve
1cb0: 72 69 66 79 20 70 72 65 2d 72 65 71 75 69 73 69  rify pre-requisi
1cc0: 74 65 73 20 61 72 65 20 6d 65 74 0a 76 65 72 69  tes are met.veri
1cd0: 66 79 52 65 71 75 69 72 65 64 50 61 63 6b 61 67  fyRequiredPackag
1ce0: 65 73 20 7c 7c 20 64 69 65 20 27 52 65 71 75 69  es || die 'Requi
1cf0: 72 65 64 20 70 61 63 6b 61 67 65 73 20 6d 69 73  red packages mis
1d00: 73 69 6e 67 27 0a 76 65 72 69 66 79 50 72 65 72  sing'.verifyPrer
1d10: 65 71 75 69 73 69 74 65 73 20 7c 7c 20 64 69 65  equisites || die
1d20: 20 27 50 72 65 72 65 71 75 69 73 69 74 69 65 73   'Prerequisities
1d30: 20 66 61 69 6c 65 64 27 0a 0a 23 20 53 74 61 72   failed'..# Star
1d40: 74 20 6c 6f 67 67 69 6e 67 0a 73 65 74 20 2d 78  t logging.set -x
1d50: 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 70 72  ..# Determine pr
1d60: 6f 70 65 72 74 69 65 73 0a 64 65 74 65 72 6d 69  operties.determi
1d70: 6e 65 50 72 65 66 69 78 0a 0a 23 20 41 70 70 6c  nePrefix..# Appl
1d80: 79 20 70 61 74 63 68 65 73 0a 61 70 70 6c 79 5f  y patches.apply_
1d90: 70 61 74 63 68 65 73 0a 0a 23 20 53 74 61 72 74  patches..# Start
1da0: 20 74 68 65 20 62 75 69 6c 64 0a 70 72 65 63 6f   the build.preco
1db0: 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27  nfigure || die '
1dc0: 70 72 65 63 6f 6e 66 69 67 75 72 65 20 66 61 69  preconfigure fai
1dd0: 6c 65 64 27 0a 63 6f 6e 66 69 67 75 72 65 20 7c  led'.configure |
1de0: 7c 20 64 69 65 20 27 63 6f 6e 66 69 67 75 72 65  | die 'configure
1df0: 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 63 6f 6e   failed'.postcon
1e00: 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 70  figure || die 'p
1e10: 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 66 61 69  ostconfigure fai
1e20: 6c 65 64 27 0a 0a 70 72 65 62 75 69 6c 64 20 7c  led'..prebuild |
1e30: 7c 20 64 69 65 20 27 70 72 65 62 75 69 6c 64 20  | die 'prebuild 
1e40: 66 61 69 6c 65 64 27 0a 62 75 69 6c 64 20 7c 7c  failed'.build ||
1e50: 20 64 69 65 20 27 62 75 69 6c 64 20 66 61 69 6c   die 'build fail
1e60: 65 64 27 0a 70 6f 73 74 62 75 69 6c 64 20 7c 7c  ed'.postbuild ||
1e70: 20 64 69 65 20 27 70 6f 73 74 62 75 69 6c 64 20   die 'postbuild 
1e80: 66 61 69 6c 65 64 27 0a 0a 70 72 65 69 6e 73 74  failed'..preinst
1e90: 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 72 65 69  all || die 'prei
1ea0: 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 69  nstall failed'.i
1eb0: 6e 73 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27 69  nstall || die 'i
1ec0: 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 70  nstall failed'.p
1ed0: 6f 73 74 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  ostinstall || di
1ee0: 65 20 27 70 6f 73 74 69 6e 73 74 61 6c 6c 20 66  e 'postinstall f
1ef0: 61 69 6c 65 64 27 0a 0a 28 0a 09 63 61 73 65 20  ailed'..(..case 
1f00: 22 24 7b 74 61 72 67 65 74 6d 6f 64 65 7d 22 20  "${targetmode}" 
1f10: 69 6e 0a 09 09 69 6e 73 74 61 6c 6c 29 0a 09 09  in...install)...
1f20: 09 61 70 70 64 69 72 3d 22 24 28 61 70 70 66 73  .appdir="$(appfs
1f30: 69 6e 73 74 61 6c 6c 64 69 72 29 2f 24 7b 70 72  installdir)/${pr
1f40: 65 66 69 78 73 75 66 66 69 78 7d 22 0a 09 09 09  efixsuffix}"....
1f50: 6d 6b 64 69 72 20 2d 70 20 22 24 7b 61 70 70 64  mkdir -p "${appd
1f60: 69 72 7d 22 0a 0a 09 09 09 63 64 20 22 24 7b 64  ir}".....cd "${d
1f70: 65 73 74 64 69 72 7d 2f 24 7b 70 72 65 66 69 78  estdir}/${prefix
1f80: 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09  }" || exit 1....
1f90: 09 63 70 20 2d 72 70 20 2a 20 22 24 7b 61 70 70  .cp -rp * "${app
1fa0: 64 69 72 7d 22 0a 09 09 09 66 69 6e 64 20 22 24  dir}"....find "$
1fb0: 7b 61 70 70 64 69 72 7d 22 20 2d 70 72 69 6e 74  {appdir}" -print
1fc0: 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75  0 | xargs -0 tou
1fd0: 63 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65  ch -t "${pkgdate
1fe0: 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 61 70  }"....find "${ap
1ff0: 70 64 69 72 7d 22 20 2d 70 72 69 6e 74 30 20 7c  pdir}" -print0 |
2000: 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63 68 20   xargs -0 touch 
2010: 2d 6d 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65  -m -t "${pkgdate
2020: 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 61 70  }"....find "${ap
2030: 70 64 69 72 7d 22 20 2d 70 72 69 6e 74 30 20 7c  pdir}" -print0 |
2040: 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63 68 20   xargs -0 touch 
2050: 2d 61 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65  -a -t "${pkgdate
2060: 7d 22 0a 09 09 09 3b 3b 0a 09 09 61 72 63 68 69  }"....;;...archi
2070: 76 65 29 0a 09 09 09 61 72 63 68 69 76 65 66 69  ve)....archivefi
2080: 6c 65 3d 22 24 7b 73 63 72 69 70 74 64 69 72 7d  le="${scriptdir}
2090: 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65 72 73 69 6f  /${pkg}-${versio
20a0: 6e 7d 2d 24 28 65 63 68 6f 20 22 24 7b 70 6b 67  n}-$(echo "${pkg
20b0: 64 61 74 65 7d 22 20 7c 20 73 65 64 20 27 73 40  date}" | sed 's@
20c0: 5c 2e 40 40 67 27 29 2d 24 7b 6f 73 7d 2d 24 7b  \.@@g')-${os}-${
20d0: 61 72 63 68 7d 2d 24 7b 64 6f 6d 61 69 6e 7d 2e  arch}-${domain}.
20e0: 63 70 69 6f 22 0a 09 09 09 63 64 20 22 24 7b 64  cpio"....cd "${d
20f0: 65 73 74 64 69 72 7d 2f 24 7b 70 72 65 66 69 78  estdir}/${prefix
2100: 7d 2f 2e 2e 2f 2e 2e 2f 2e 2e 22 20 7c 7c 20 65  }/../../.." || e
2110: 78 69 74 20 31 0a 09 09 09 66 69 6e 64 20 22 24  xit 1....find "$
2120: 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 20  {prefixsuffix}" 
2130: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
2140: 2d 30 20 74 6f 75 63 68 20 2d 74 20 22 24 7b 70  -0 touch -t "${p
2150: 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64  kgdate}"....find
2160: 20 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78   "${prefixsuffix
2170: 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72  }" -print0 | xar
2180: 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 6d 20 2d  gs -0 touch -m -
2190: 74 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09  t "${pkgdate}"..
21a0: 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78  ..find "${prefix
21b0: 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30  suffix}" -print0
21c0: 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63   | xargs -0 touc
21d0: 68 20 2d 61 20 2d 74 20 22 24 7b 70 6b 67 64 61  h -a -t "${pkgda
21e0: 74 65 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b  te}"....find "${
21f0: 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 20 7c  prefixsuffix}" |
2200: 20 73 6f 72 74 20 7c 20 63 70 69 6f 20 2d 2d 6f   sort | cpio --o
2210: 77 6e 65 72 20 30 3a 30 20 2d 48 20 6e 65 77 63  wner 0:0 -H newc
2220: 20 2d 6f 20 3e 20 22 24 7b 61 72 63 68 69 76 65   -o > "${archive
2230: 66 69 6c 65 7d 22 0a 09 09 09 3b 3b 0a 09 65 73  file}"....;;..es
2240: 61 63 0a 29 20 7c 7c 20 64 69 65 20 27 66 69 6e  ac.) || die 'fin
2250: 61 6c 20 69 6e 73 74 61 6c 6c 61 74 69 6f 6e 20  al installation 
2260: 66 61 69 6c 65 64 27 0a 0a 63 6c 65 61 6e 75 70  failed'..cleanup
2270: 0a 0a 65 78 69 74 20 30 0a                       ..exit 0.